import josx.platform.rcx.*;

public class Receiver1 {
  private static byte[] buffer = new byte[2];
	private static byte[] dat    = {(byte) 247, 0, 0, 0, 0};
 
	
	private static void vor(){
  	Motor.A.forward();
  	Motor.C.forward();
  }
	private static void links(){
  	Motor.A.forward();
  	Motor.C.backward();
  }
	private static void rechts(){
  	Motor.A.backward();
  	Motor.C.forward();
  }
	private static void zurueck(){
  	Motor.A.backward();
  	Motor.C.backward();
  }
	private static void stop(){
  	Motor.A.stop();
  	Motor.C.stop();
  }
	private static void setSpeed(byte pbSpeed) {
  	Motor.A.setPower(pbSpeed);
  	Motor.C.setPower(pbSpeed);
  }

	private static void sendLightSensorVal() {
  	intToByteArray(Sensor.S3.readValue(), dat, 1);
  	Serial.sendPacket(dat, 0, 5);
	}
	private static void sendTouchSensorVal() {
  	intToByteArray(Sensor.S1.readValue(), dat, 1);
  	Serial.sendPacket(dat, 0, 5);
	}
	
  public static void main(String [] args) throws Exception {
	  Motor.A.setPower(7);
    Motor.C.setPower(7);
    
    Sensor.S1.setTypeAndMode(SensorConstants.SENSOR_TYPE_TOUCH, SensorConstants.SENSOR_MODE_RAW);
    Sensor.S1.activate();
    
    Sensor.S3.setTypeAndMode(SensorConstants.SENSOR_TYPE_LIGHT, SensorConstants.SENSOR_MODE_PCT);
    Sensor.S3.activate();
    
    while (true) {
      if(Serial.isPacketAvailable()) {
      	Serial.readPacket(buffer);
        byte rB = buffer[1];
        if ((rB > -1) && (rB < 8)) {
        	setSpeed(rB);
        } else if (rB ==  8) {
        	vor();
        } else if (rB ==  9) {
        	zurueck();
        } else if (rB == 10) {
           links();
        } else if (rB == 11) {
           rechts();
        } else if (rB == 12) {
           stop();
        } else if (rB == 13) {
        	Player.playBass();
        } else if (rB == 14) {
        	sendLightSensorVal();
        } else if (rB == 15) {
        	sendTouchSensorVal();
        }
      }
    }
  }
  
  
	private static void intToByteArray(int piValue, byte[] pbArr, int piOff) {
		for (int iCnt = 0; iCnt < 4; iCnt++) {
			pbArr[piOff + iCnt] = (byte) ((piValue >> (iCnt * 8)) & 0xFF);
		}
	}
	
}